"""
Script to convert mnemonic into private key
:author: gurnoorsingh (20221006)
"""

import argparse
from algosdk import kmd, mnemonic

parser = argparse.ArgumentParser()
parser.add_argument("--kmd-token", "-t", help="kmd token", required=True)
parser.add_argument(
    "--kmd-address", "-d", help="kmd server address", default="http://127.0.0.1:7833"
)
parser.add_argument("--wallet", "-w", help="Wallet name", required=True)
parser.add_argument("--wallet-pswd", "-p", help="Wallet password", required=True)
parser.add_argument(
    "--account-addr",
    "-a",
    help="Account address for which need the private key",
    required=True,
)
args = parser.parse_args()

# create a kmd client
kcl = kmd.KMDClient(args.kmd_token, args.kmd_address)

walletid = None
wallets = kcl.list_wallets()
for arrayitem in wallets:
    if arrayitem.get("name") == args.wallet:
        walletid = arrayitem.get("id")
        break

wallethandle = kcl.init_wallet_handle(walletid, args.wallet_pswd)
accountkey = kcl.export_key(wallethandle, args.wallet_pswd, args.account_addr)
print("Account key: ", accountkey)
mn = mnemonic.from_private_key(accountkey)
print("Account Mnemonic: ", mn)
